//+------------------------------------------------------------------+
//|                                                  RSI on NMA.mq4  |
//|                                         by brax64 for forex-tsd  |
//+------------------------------------------------------------------+

#property copyright "brax64"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DodgerBlue  
#property indicator_width1  2


extern int RsiPeriod     = 14;
extern int RsiPrice      = PRICE_CLOSE;
extern int NMA_Length    = 7;
extern int NMA_S_Length  = 3;
extern int NMA_Mode      = MODE_LWMA;
extern int Smooth_Length = 3;
extern int Smooth_Mode   = MODE_SMMA;

double rsi[];
double sig[];
double nma[];
double nma_s[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,sig);
   SetIndexBuffer(2,nma);
   SetIndexBuffer(3,nma_s);
   IndicatorShortName("RSI on NMA ("+RsiPeriod+","+NMA_Length+","+Smooth_Length+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
         
   double Lambda = NMA_Length / NMA_S_Length;
   if(Lambda < 2.0)
   {
      Lambda = 2.0;
      NMA_S_Length = NMA_Length / 2.0;
   }
   double Alpha  = Lambda * (NMA_Length - 1.0) / (NMA_Length - Lambda);

   for (i = limit; i >= 0; i--)  nma_s[i] = iMA(NULL, 0, NMA_Length, 0, NMA_Mode, RsiPrice, i);
   for (i = limit; i >= 0; i--)
   {   
      double Gamma    = iMAOnArray(nma_s,0,NMA_S_Length,0,NMA_Mode,i);
             nma[i]   = (Alpha+1.0)*nma_s[i] - Alpha*Gamma;
   }


   for(i=limit; i>=0; i--) sig[i] = iRsi(nma[i],RsiPeriod,i);
   if(Smooth_Length < 1) Smooth_Length = 1;
   for(i=limit; i>=0; i--) rsi[i] = iMAOnArray(sig,0,Smooth_Length,0,Smooth_Mode,i);
   
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------

double workRsi[][1];
#define _price  0

double iRsi(double price, double period, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo; 
      int r = Bars-i-1;
   
      workRsi[r][z+_price] = price;

      
         double sump = 0;
         double sumn = 0;
         for (int k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
}